git-pull.shon commit Merge branch 'master' into sp/fast-import (1fcdd62)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# Fetch one or more remote refs and merge it/them into the current HEAD.
   6
   7USAGE='[-n | --no-summary] [--no-commit] [-s strategy]... [<fetch-options>] <repo> <head>...'
   8LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
   9. git-sh-setup
  10set_reflog_action "pull $*"
  11require_work_tree
  12
  13test -z "$(git ls-files -u)" ||
  14        die "You are in a middle of conflicted merge."
  15
  16strategy_args= no_summary= no_commit= squash=
  17while case "$#,$1" in 0) break ;; *,-*) ;; *) break ;; esac
  18do
  19        case "$1" in
  20        -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
  21                --no-summa|--no-summar|--no-summary)
  22                no_summary=-n ;;
  23        --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
  24                no_commit=--no-commit ;;
  25        --sq|--squ|--squa|--squas|--squash)
  26                squash=--squash ;;
  27        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
  28                --strateg=*|--strategy=*|\
  29        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
  30                case "$#,$1" in
  31                *,*=*)
  32                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
  33                1,*)
  34                        usage ;;
  35                *)
  36                        strategy="$2"
  37                        shift ;;
  38                esac
  39                strategy_args="${strategy_args}-s $strategy "
  40                ;;
  41        -h|--h|--he|--hel|--help)
  42                usage
  43                ;;
  44        -*)
  45                # Pass thru anything that is meant for fetch.
  46                break
  47                ;;
  48        esac
  49        shift
  50done
  51
  52orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
  53git-fetch --update-head-ok "$@" || exit 1
  54
  55curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
  56if test "$curr_head" != "$orig_head"
  57then
  58        # The fetch involved updating the current branch.
  59
  60        # The working tree and the index file is still based on the
  61        # $orig_head commit, but we are merging into $curr_head.
  62        # First update the working tree to match $curr_head.
  63
  64        echo >&2 "Warning: fetch updated the current branch head."
  65        echo >&2 "Warning: fast forwarding your working tree from"
  66        echo >&2 "Warning: commit $orig_head."
  67        git-update-index --refresh 2>/dev/null
  68        git-read-tree -u -m "$orig_head" "$curr_head" ||
  69                die 'Cannot fast-forward your working tree.
  70After making sure that you saved anything precious from
  71$ git diff '$orig_head'
  72output, run
  73$ git reset --hard
  74to recover.'
  75
  76fi
  77
  78merge_head=$(sed -e '/  not-for-merge   /d' \
  79        -e 's/  .*//' "$GIT_DIR"/FETCH_HEAD | \
  80        tr '\012' ' ')
  81
  82case "$merge_head" in
  83'')
  84        curr_branch=$(git-symbolic-ref HEAD | \
  85                sed -e 's|^refs/heads/||')
  86        echo >&2 "Warning: No merge candidate found because value of config option
  87         \"branch.${curr_branch}.merge\" does not match any remote branch fetched."
  88        echo >&2 "No changes."
  89        exit 0
  90        ;;
  91?*' '?*)
  92        if test -z "$orig_head"
  93        then
  94                echo >&2 "Cannot merge multiple branches into empty head"
  95                exit 1
  96        fi
  97        ;;
  98esac
  99
 100if test -z "$orig_head"
 101then
 102        git-update-ref -m "initial pull" HEAD $merge_head "" &&
 103        git-read-tree --reset -u HEAD || exit 1
 104        exit
 105fi
 106
 107merge_name=$(git-fmt-merge-msg <"$GIT_DIR/FETCH_HEAD") || exit
 108exec git-merge $no_summary $no_commit $squash $strategy_args \
 109        "$merge_name" HEAD $merge_head